﻿using C1.Win.FlexGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace FlexGrid_QuickStart.CustomeFilters
{
    public class CustomColumnFilter : ColumnFilter
    {
        #region Properties
        private ColumnFilter columnFilterDefault;
        private bool _isFilterDefault = true;

        public ColumnFilter FilterDefault
        {
            get
            {
                return this.columnFilterDefault;
            }
        }

        public bool IsFilterDefault
        {
            get
            {
                return this._isFilterDefault;
            }
            set
            {
                this._isFilterDefault = value;
            }
        }
        #endregion

        #region C'tor
        public CustomColumnFilter()
        {
            this.columnFilterDefault = new ColumnFilter();
        }
        #endregion

        #region Overriden
        public override bool IsActive
        {
            get
            {
                if (this._isFilterDefault == true)
                {
                    return this.columnFilterDefault.IsActive;
                }
                return this.Monday == false || this.Tuesday == false || this.Wednesday == false || this.Thursday == false ||
                     this.Friday == false || this.Saturday == false || this.Sunday == false;
            }
        }

      
        public override IC1ColumnFilterEditor GetEditor()
        {
            return new CustomColumnFilterEditor();
        }

        public override bool Apply(object value)
        {
            if (this._isFilterDefault == true)
            {
                return this.columnFilterDefault.Apply(value);
            }
            else
            {
                DateTime datValue = (DateTime)value;
                if (datValue.DayOfWeek == DayOfWeek.Monday && this.Monday == true)
                {
                    return true;
                }
                else if (datValue.DayOfWeek == DayOfWeek.Tuesday && this.Tuesday == true)
                {
                    return true;
                }
                else if (datValue.DayOfWeek == DayOfWeek.Wednesday && this.Wednesday == true)
                {
                    return true;
                }
                else if (datValue.DayOfWeek == DayOfWeek.Thursday && this.Thursday == true)
                {
                    return true;
                }
                else if (datValue.DayOfWeek == DayOfWeek.Friday && this.Friday == true)
                {
                    return true;
                }
                else if (datValue.DayOfWeek == DayOfWeek.Saturday && this.Saturday == true)
                {
                    return true;
                }
                else if (datValue.DayOfWeek == DayOfWeek.Sunday && this.Sunday == true)
                {
                    return true;
                }
                return false;
            }            
        }

        public override void Reset()
        {
            this.columnFilterDefault.Reset();

            this.Monday = true;
            this.Tuesday = true;
            this.Wednesday = true;
            this.Thursday = true;
            this.Friday = true;
            this.Saturday = true;
            this.Sunday = true;
        }

        public override void ReadXmlDefinition(XmlReader xr)
        {
            base.ReadXmlDefinition(xr);
        }
        public override void WriteXmlDefinition(XmlWriter xw)
        {
            base.WriteXmlDefinition(xw);
        }
        #endregion

        public bool Monday
        {
            get;
            set;
        } = true;


        public bool Tuesday
        {
            get;
            set;
        } = true;


        public bool Wednesday
        {
            get;
            set;
        } = true;


        public bool Thursday
        {
            get;
            set;
        } = true;


        public bool Friday
        {
            get;
            set;
        } = true;


        public bool Saturday
        {
            get;
            set;
        } = true;


        public bool Sunday
        {
            get;
            set;
        } = true;
    }
}

